
#include <windows.h>
#include <stdio.h>
#include <math.h>


#pragma argsused
BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fwdreason, LPVOID lpvReserved)
{
    switch (fwdreason)
    {
    case DLL_PROCESS_ATTACH:
      break;
    case DLL_PROCESS_DETACH:
      break;
    case DLL_THREAD_ATTACH:
      break;
    case DLL_THREAD_DETACH:
      break;
    }
        return 1;
}
//-----------------------------------------------------------------------
void dllfunc1(int *m_fout,int *n_x_est, double *x_est, double *param, double *fout)
{
//
//   n   is the dimension of vector  x
//   m   is the dimension of vector  f
//----------------------------------------------------------------
//             input              output                work_area
//
//  param[i] = tm[i], param[m+i] = ym[i], param[2m+i] = wk0[i]
//

  int i,j,m0,n0;
  double a0,a1,b1,b1m, x0;
  double *y, *x, *z, *wk;

  m0= *m_fout;
  n0= *n_x_est;

  if( n0 == 2)
  {
    a0= x_est[0];
    a1= 0.0;
    b1= x_est[1];
  }
  else
  {
    a0= x_est[0];
    a1= x_est[1];
    b1= x_est[2];
  }
  x=  param;
  y=  (param + m0);
  wk=  (param + (2 * m0));
  z= fout;

  b1m= -1.0 * b1;

  wk[0]=a0;
  wk[1]=(a1 -b1 *a0);
  for(i=2;i<m0;++i)
  {
    wk[i]=wk[i-1] * b1m;
  }

  for(i=0;i<m0;++i )
  {
    x0=0.0;
    for(j=0;j<=i;++j)
    {
      x0+= wk[i-j] * x[j];
    }
    z[i] = x0 - y[i];
  }

}
//---------------------------------------------------------------------------
void dlldfunc1(int *m_fout,int *n_x_est, double *x_est, double *param, double *fout)
{
//
//   n   is the dimension of vector  x
//   m   is the dimension of vector  f
//----------------------------------------------------------------
//             input              output                work_area
//  param[i] = tm[i], param[m+i] = ym[i], param[2m+i] = wk0[i]

  int i,j,m0,n0,m1;
  double a0,a1,b1,b1m, x0;
  double *y, *x, *z, *wk;

  m0= *m_fout;
  n0= *n_x_est;

  if( n0 == 2)
  {
    a0= x_est[0];
    a1= 0.0;
    b1= x_est[1];
  }
  else
  {
    a0= x_est[0];
    a1= x_est[1];
    b1= x_est[2];
  }
  x=  param;
  y=  (param + m0);
  wk=  (param + (2 * m0));
  z= fout;

  b1m= -1.0 * b1;

  // dy/da0
  wk[0]=1.0;
  for(i=1;i<m0;++i)
  {
    wk[i]=wk[i-1] * b1m;
  }
  for(i=0;i<m0;++i )
  {
    x0=0.0;
    for(j=0;j<=i;++j)
    {
      x0+= wk[i-j] * x[j];
    }
    z[i]= x0;
  }

  // dy/da1
  if(  n0 != 2)
  {
    wk[0]=0.0;
    wk[1]= 1.0;
    for(i=2;i<m0;++i)
    {
      wk[i]= wk[i-1] * b1m;
    }

    for(i=0;i<m0;++i )
    {
      x0=0.0;
      for(j=0;j<=i;++j)
      {
        x0+= wk[i-j] * x[j];
      }
      z[m0 + i]= x0;
    }
  }

  // dy/db1
  if(  n0 == 2) { m1= m0;}
  else { m1= m0 * 2; }

  wk[0]=0.0;
  wk[1]= -1.0 * a0;
  x0= 1.0;
  
  for(i=2;i<m0;++i)
  {
    wk[i]= - 1.0 * (double)(i - 1) * x0 * a1;
    x0=x0 * b1m;
    wk[i] = wk[i] - 1.0 * (double)(i) * x0 * a0;
  }
  for(i=0;i<m0;++i )
  {
    x0=0.0;
    for(j=0;j<=i;++j)
    {
      x0+= wk[i-j] * x[j];
    }
    z[m1 + i]= x0;
  }
  
}
//------------------------------------------------------------------------
